from bu4.parsing.linked import Linked
from bu4.evaluation.aftervalue import Evaluable, envtype


class ELinked(Evaluable):
    def __init__(self, env: envtype, linked: Linked):
        self.env = env
        self.linked = linked

    def next(self) -> Evaluable:
        return self.linked.evaluable(self.env)

    def __str__(self):
        return f'{self.linked}'
