from bu4.linking.afterlinking import AfterLinking
from bu4.linking.altarget import ALTarget
from bu4.parsing.linked import Linked, LinkingState


class ALAL(ALTarget):
    def __init__(self, target: ALTarget, aftertarget: ALTarget):
        self.target = target
        self.aftertarget = aftertarget

    def given(self, linked: Linked) -> LinkingState:
        return AfterLinking(self.target.given(linked), self.aftertarget)
