from typing import Callable

from bu4.linking.altarget import ALTarget
from bu4.parsing.linked import Linked, LinkingState


class ALLambda(ALTarget):
    def __init__(self, lambda_: Callable[[Linked], LinkingState]):
        self.lambda_ = lambda_

    def given(self, linked: Linked) -> LinkingState:
        return self.lambda_(linked)
