from bu4.evaluation.aftervalue import EValue
from bu4.toolchain.elinked import elinked
from bu4.toolchain.parse import parse
from bu4.toolchain.sync import sync
from bu4.toolchain.transply import transply


def synced(source: str) -> EValue:
    bsource = transply(source)
    parsed = parse(bsource)
    evaluable = elinked({}, parsed)
    return sync(evaluable)
